// testGrab.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "CMUCameraGrab.h"
extern C1394Camera Camera;  //use if you want to expose the CMU camera object
int _tmain(int argc, _TCHAR* argv[])
{
	BOOL vid=FALSE; //set true to record
	//video writer
	CvVideoWriter *vidWrite=NULL;
	if(vid)
	//	vidWrite=cvCreateVideoWriter("c:\\testgrab.avi",CV_FOURCC('H','F','Y','U'),15,cvSize(640,480),1);
		vidWrite=cvCreateVideoWriter("c:\\testgrab.avi",-1,15,cvSize(640,480),1);

	if(setupFWCamera(640,480,15,YUV422)!=0)
	{
		printf("Error: failed to set up camera\n");
		getch();
		return 0;
	}
	//get the current camera setting and display
	int format=0,mode=0,wd=0,ht=0;
	if(getCurrentCameraFormat(&format,&mode)==-1)
	{ printf("Can not get mode and format\n");}

	printf("Current mode %d, format %d\n",mode,format);
	ColourSpace col;
	getWidthHeight(format, mode, &wd,&ht, &col);
	char colstring[8];
	getColourString(col,colstring);
	printf("Width %d, height %d, colourspace %s\n",wd,ht,colstring);
	//list all the supported modes
	listSupportedModes();

	//CMU functionality is still exposed, eg
	char tmp[256];
	Camera.GetCameraVendor(tmp,256);
	printf("Camera vendor %s\n",tmp);
	Camera.GetCameraName(tmp,256);
	printf("Camera name %s\n",tmp);
	
	//start to acquire images
	if(startImageAcquisition()!=0)
	{
		printf("Error: failed to set up camera acquisition\n");
		getch();
		return 0;
	}
	//open an opencv window    
    cvNamedWindow( "Source",0);     
    //create IplImages
    IplImage *Image = cvCreateImage( cvSize(640, 480), 8, 3);
	clock_t start=clock();
	int cw=0;
	while(cw!=32) //exit when space key pressed
	{
		//grab an image
		if(getFWImage(Image)==-1)
		{
			printf("Failed to grab image\n");
			break;
		}
		BRG2RGB(Image); //flip colour spaces
		cvShowImage("Source", Image);
		if(vid)
			cvWriteFrame(vidWrite,Image);
	
		cw=cvWaitKey(10);
        if(clock()>start+240*CLOCKS_PER_SEC) //wait 2 mins
			cw=32;
	}
	stopFWCamera();
	if(vid)
		cvReleaseVideoWriter(&vidWrite);
	return 0;
}

